/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.cpu.metadata;

import static ru.ispras.microtesk.model.cpu.TypeDefs.*;

import ru.ispras.microtesk.model.api.data.Type;
import ru.ispras.microtesk.model.api.metadata.MetaModel;
import ru.ispras.microtesk.model.api.metadata.MetaModelBuilder;

/**
 * The {@code MetaModelFactory} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class MetaModelFactory {
  private MetaModelFactory() {}

  public static MetaModel newMetaModel() {
    final MetaModelBuilder builder = new MetaModelBuilder();

    builder.addRegister("GPR", BYTE, 16);
    builder.addRegister("PC", INDEX, 1);

    builder.addMemory("M", BYTE, 0x100);

    builder.addMode(IMM.get());
    builder.addMode(REG.get());
    builder.addMode(MEM.get());
    builder.addMode(OPRNDL.get());
    builder.addMode(OPRNDR.get());

    builder.addOperation(ADD.get());
    builder.addOperation(SUB.get());
    builder.addOperation(MOV.get());
    builder.addOperation(ALU.get());
    builder.addOperation(alu_instr.get());
    builder.addOperation(J.get());
    builder.addOperation(JZ.get());
    builder.addOperation(branch_instr.get());
    builder.addOperation(instruction.get());

    return builder.build();
  }
}
