/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.cpu.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.PEState;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.cpu.PE;
import ru.ispras.microtesk.model.cpu.mode.*;

import static ru.ispras.microtesk.model.cpu.TypeDefs.*;

public final class alu_instr extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         alu_instr.class,
         "alu_instr",
         new ArgumentDecls()
             .add("command", ALU.INFO)
             .add("op1", OPRNDL.INFO)
             .add("op2", OPRNDR.INFO));
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final Operation command = (Operation) getArgument("command", args);
      final AddressingMode op1 = (AddressingMode) getArgument("op1", args);
      final AddressingMode op2 = (AddressingMode) getArgument("op2", args);

      return new alu_instr(command, op1, op2);
    }
  }
  public static final IInfo INFO = new Info();

  public final Operation command;
  public final AddressingMode op1;
  public final AddressingMode op2;

  public alu_instr(final Operation command, final AddressingMode op1, final AddressingMode op2) {
    assert ALU.INFO.isSupported(command);
    assert OPRNDL.INFO.isSupported(op1);
    assert OPRNDR.INFO.isSupported(op2);
    this.command = command;
    this.op1 = op1;
    this.op2 = op2;
  }

  @Override
  public String syntax(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("%s %s %s", command.syntax(peState), op1.syntax(peState), op2.syntax(peState));
  }

  @Override
  public String image(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("%s%s00%s", command.image(peState), op1.image(peState), op2.image(peState));
  }

  @Override
  public void action(final PEState peState) {
    final PE pe__ = (PE) peState;
    pe__.SRC1.access().store(op1.access(pe__).load());
    pe__.SRC2.access().store(op2.access(pe__).load());
    command.execute(pe__);
    op1.access(pe__).store(pe__.DEST.access().load());
    pe__.PC.access().store(pe__.PC.access().load().add(Data.valueOf(INDEX, 0x2)));
  }
}