/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips;

import java.math.BigInteger;
import ru.ispras.microtesk.model.api.PEState;
import ru.ispras.microtesk.model.api.data.Type;
import ru.ispras.microtesk.model.api.memory.Label;
import ru.ispras.microtesk.model.api.memory.Memory;

/**
 * The {@code PE} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class PE extends PEState {
  public final Memory GPR;
  public final Memory COP0_R;
  public final Memory HI;
  public final Memory LO;
  public final Memory CIA;
  public final Memory M;
  public final Memory BRANCH;
  public final Memory JMPADDR;
  public final Memory is_delay_slot;
  public final Memory jump_address;
  public final Memory nia;
  public final Memory temp;
  public final Memory temp_jump;
  public final Memory mult_result;
  public final Memory mult_result_unsigned;

  public PE() {
    this.GPR = Memory.def(Memory.Kind.REG, "GPR", TypeDefs.WORD, 0x20);
    this.COP0_R = Memory.def(Memory.Kind.REG, "COP0_R", TypeDefs.WORD, 0x20);
    this.HI = Memory.def(Memory.Kind.REG, "HI", TypeDefs.WORD, 0x1);
    this.LO = Memory.def(Memory.Kind.REG, "LO", TypeDefs.WORD, 0x1);
    this.CIA = Memory.def(Memory.Kind.REG, "CIA", TypeDefs.WORD, 0x1);
    this.M = Memory.def(Memory.Kind.MEM, "M", TypeDefs.WORD, 0x40000000);
    this.BRANCH = Memory.def(Memory.Kind.REG, "BRANCH", TypeDefs.BIT, 0x1);
    this.JMPADDR = Memory.def(Memory.Kind.REG, "JMPADDR", TypeDefs.WORD, 0x1);
    this.is_delay_slot = Memory.def(Memory.Kind.VAR, "is_delay_slot", TypeDefs.BIT, 0x1);
    this.jump_address = Memory.def(Memory.Kind.VAR, "jump_address", TypeDefs.WORD, 0x1);
    this.nia = Memory.def(Memory.Kind.VAR, "nia", TypeDefs.WORD, 0x1);
    this.temp = Memory.def(Memory.Kind.VAR, "temp", Type.INT(33), 0x1);
    this.temp_jump = Memory.def(Memory.Kind.VAR, "temp_jump", Type.CARD(28), 0x1);
    this.mult_result = Memory.def(Memory.Kind.VAR, "mult_result", Type.INT(64), 0x1);
    this.mult_result_unsigned = Memory.def(Memory.Kind.VAR, "mult_result_unsigned", Type.CARD(64), 0x1);

    registerAll();
  }

  public PE(final PE other) {
    this.GPR = other.GPR;
    this.COP0_R = other.COP0_R;
    this.HI = other.HI;
    this.LO = other.LO;
    this.CIA = other.CIA;
    this.M = other.M;
    this.BRANCH = other.BRANCH;
    this.JMPADDR = other.JMPADDR;
    this.is_delay_slot = other.is_delay_slot;
    this.jump_address = other.jump_address;
    this.nia = other.nia;
    this.temp = other.temp;
    this.temp_jump = other.temp_jump;
    this.mult_result = other.mult_result;
    this.mult_result_unsigned = other.mult_result_unsigned;

    registerAll();
  }

  private void registerAll() {
    addStorage(GPR);
    addStorage(COP0_R);
    addStorage(HI);
    addStorage(LO);
    addStorage(CIA);
    addStorage(M);
    addStorage(BRANCH);
    addStorage(JMPADDR);
    addStorage(is_delay_slot);
    addStorage(jump_address);
    addStorage(nia);
    addStorage(temp);
    addStorage(temp_jump);
    addStorage(mult_result);
    addStorage(mult_result_unsigned);

    addLabel(new Label("PC", CIA, 0));
  }
}
