/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.PEState;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.minimips.PE;
import ru.ispras.microtesk.model.minimips.mode.*;

import static ru.ispras.microtesk.model.minimips.TypeDefs.*;

public final class add extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         add.class,
         "add",
         new ArgumentDecls()
             .add("rd", REG.INFO)
             .add("rs", REG.INFO)
             .add("rt", REG.INFO),
         new Shortcuts()
             .addShortcut(new Info_instruction(), "#root")
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final REG rd = (REG) getArgument("rd", args);
      final REG rs = (REG) getArgument("rs", args);
      final REG rt = (REG) getArgument("rt", args);

      return new add(rd, rs, rt);
    }
  }
  private static final class Info_instruction extends InfoAndRule {
    Info_instruction() {
      super(
          instruction.class,
          "add",
          new ArgumentDecls()
              .add("rd", REG.INFO)
              .add("rs", REG.INFO)
              .add("rt", REG.INFO)
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final REG rd = (REG) getArgument("rd", args);
      final REG rs = (REG) getArgument("rs", args);
      final REG rt = (REG) getArgument("rt", args);

      return new instruction(
        new add(
          rd,
          rs,
          rt
        )
      );
    }
  }
  public static final IInfo INFO = new Info();

  public final REG rd;
  public final REG rs;
  public final REG rt;

  public add(final REG rd, final REG rs, final REG rt) {
    assert REG.INFO.isSupported(rd);
    assert REG.INFO.isSupported(rs);
    assert REG.INFO.isSupported(rt);
    this.rd = rd;
    this.rs = rs;
    this.rt = rt;
  }

  @Override
  public String syntax(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("add %s, %s, %s", rd.syntax(peState), rs.syntax(peState), rt.syntax(peState));
  }

  @Override
  public String image(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("000000%s%s%s00000100000", rs.image(peState), rt.image(peState), rd.image(peState));
  }

  @Override
  public void action(final PEState peState) {
    final PE pe__ = (PE) peState;
    pe__.temp.access().store(Location.concat(rs.access(pe__), rs.access(pe__).bitField(31, 31)).load().add(Location.concat(rt.access(pe__), rt.access(pe__).bitField(31, 31)).load()));
    if (!pe__.temp.access().bitField(32, 32).load().equals(pe__.temp.access().bitField(31, 31).load())) {
      Execution.mark("overflow");
      pe__.COP0_R.access(14).store(pe__.CIA.access().load());
      Execution.exception("IntegerOverflow");
    } else {
      Execution.mark("normal");
      rd.access(pe__).store(pe__.temp.access().bitField(31, 0).load());
    }
  }
}