/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.PEState;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.minimips.PE;
import ru.ispras.microtesk.model.minimips.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.minimips.TypeDefs.*;

public final class la extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         la.class,
         "la",
         new ArgumentDecls()
             .add("rd", REG.INFO)
             .add("addr", WORD));
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final REG rd = (REG) getArgument("rd", args);
      final Immediate addr = (Immediate) getArgument("addr", args);

      return new la(rd, addr);
    }
  }
  public static final IInfo INFO = new Info();

  public final REG rd;
  public final Immediate addr;

  public la(final REG rd, final Immediate addr) {
    assert REG.INFO.isSupported(rd);
    assert WORD.equals(addr.getType());
    this.rd = rd;
    this.addr = addr;
  }

  @Override
  public String syntax(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("la %s, <label>%d", rd.syntax(peState), addr.access(pe__).load().bigIntegerValue());
  }

  @Override
  public String image(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("%s%s", new lui(rd, new Immediate(addr.access(pe__).bitField(16, 31))).image(peState), new ori(rd, rd, new Immediate(addr.access(pe__).bitField(0, 15))).image(peState));
  }

  @Override
  public void action(final PEState peState) {
    final PE pe__ = (PE) peState;
    new instruction(new lui(rd, new Immediate(addr.access(pe__).bitField(16, 31)))).execute(pe__);
    new instruction(new ori(rd, rd, new Immediate(addr.access(pe__).bitField(0, 15)))).execute(pe__);
  }
}