/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.PEState;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.minimips.PE;
import ru.ispras.microtesk.model.minimips.mode.*;

import static ru.ispras.microtesk.model.minimips.TypeDefs.*;

public final class srav extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         srav.class,
         "srav",
         new ArgumentDecls()
             .add("rd", REG.INFO)
             .add("rt", REG.INFO)
             .add("rs", REG.INFO),
         new Shortcuts()
             .addShortcut(new Info_instruction(), "#root")
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final REG rd = (REG) getArgument("rd", args);
      final REG rt = (REG) getArgument("rt", args);
      final REG rs = (REG) getArgument("rs", args);

      return new srav(rd, rt, rs);
    }
  }
  private static final class Info_instruction extends InfoAndRule {
    Info_instruction() {
      super(
          instruction.class,
          "srav",
          new ArgumentDecls()
              .add("rd", REG.INFO)
              .add("rt", REG.INFO)
              .add("rs", REG.INFO)
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final REG rd = (REG) getArgument("rd", args);
      final REG rt = (REG) getArgument("rt", args);
      final REG rs = (REG) getArgument("rs", args);

      return new instruction(
        new srav(
          rd,
          rt,
          rs
        )
      );
    }
  }
  public static final IInfo INFO = new Info();

  public final REG rd;
  public final REG rt;
  public final REG rs;

  public srav(final REG rd, final REG rt, final REG rs) {
    assert REG.INFO.isSupported(rd);
    assert REG.INFO.isSupported(rt);
    assert REG.INFO.isSupported(rs);
    this.rd = rd;
    this.rt = rt;
    this.rs = rs;
  }

  @Override
  public String syntax(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("srav %s, %s, %s", rd.syntax(peState), rt.syntax(peState), rs.syntax(peState));
  }

  @Override
  public String image(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("00000000000%s%s%s000111", rt.image(peState), rd.image(peState), rs.image(peState));
  }

  @Override
  public void action(final PEState peState) {
    final PE pe__ = (PE) peState;
    rd.access(pe__).store(rt.access(pe__).load().shiftRight(rs.access(pe__).bitField(4, 0).load()));
  }
}