/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vliw.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.PEState;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.vliw.PE;
import ru.ispras.microtesk.model.vliw.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.vliw.TypeDefs.*;

public final class BEQ extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         BEQ.class,
         "BEQ",
         new ArgumentDecls()
             .add("rs", R.INFO)
             .add("rt", R.INFO)
             .add("offset", SHORT));
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final R rs = (R) getArgument("rs", args);
      final R rt = (R) getArgument("rt", args);
      final Immediate offset = (Immediate) getArgument("offset", args);

      return new BEQ(rs, rt, offset);
    }
  }
  public static final IInfo INFO = new Info();

  public final R rs;
  public final R rt;
  public final Immediate offset;

  public BEQ(final R rs, final R rt, final Immediate offset) {
    assert R.INFO.isSupported(rs);
    assert R.INFO.isSupported(rt);
    assert SHORT.equals(offset.getType());
    this.rs = rs;
    this.rt = rt;
    this.offset = offset;
  }

  @Override
  public String syntax(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("BEQ %s, %s, <label>%d", rs.syntax(peState), rt.syntax(peState), offset.access(pe__).load().bigIntegerValue());
  }

  @Override
  public String image(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("000100%s%s%s", rs.image(peState), rt.image(peState), offset.access(pe__).load().toString());
  }

  @Override
  public void action(final PEState peState) {
    final PE pe__ = (PE) peState;
    if (rs.access(pe__).load().equals(rt.access(pe__).load())) {
      pe__.BRANCH.access().store(Data.valueOf(BIT, 0x1));
      pe__.JMPADDR.access().store(pe__.NIA.access().load().add(Data.signExtend(WORD, offset.access(pe__).load()).shiftLeft(Data.valueOf(WORD, 0x3))));
    }
  }
}