/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vliw.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.PEState;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.vliw.PE;
import ru.ispras.microtesk.model.vliw.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.vliw.TypeDefs.*;

public final class LUI extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         LUI.class,
         "LUI",
         new ArgumentDecls()
             .add("rt", R.INFO)
             .add("offset", SHORT));
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final R rt = (R) getArgument("rt", args);
      final Immediate offset = (Immediate) getArgument("offset", args);

      return new LUI(rt, offset);
    }
  }
  public static final IInfo INFO = new Info();

  public final R rt;
  public final Immediate offset;

  public LUI(final R rt, final Immediate offset) {
    assert R.INFO.isSupported(rt);
    assert SHORT.equals(offset.getType());
    this.rt = rt;
    this.offset = offset;
  }

  @Override
  public String syntax(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("LUI %s, 0x%x", rt.syntax(peState), offset.access(pe__).load().bigIntegerValue(false));
  }

  @Override
  public String image(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("00111100000%s%s", rt.image(peState), offset.access(pe__).load().toString());
  }

  @Override
  public void action(final PEState peState) {
    final PE pe__ = (PE) peState;
    rt.access(pe__).store(Data.signExtend(WORD, offset.access(pe__).load()).shiftLeft(Data.valueOf(WORD, 0x10)));
  }
}