/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vliw.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.PEState;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.vliw.PE;
import ru.ispras.microtesk.model.vliw.mode.*;

import static ru.ispras.microtesk.model.vliw.TypeDefs.*;

public final class MOVZ_S extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         MOVZ_S.class,
         "MOVZ_S",
         new ArgumentDecls()
             .add("fd", F.INFO)
             .add("fs", F.INFO)
             .add("rt", R.INFO));
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final F fd = (F) getArgument("fd", args);
      final F fs = (F) getArgument("fs", args);
      final R rt = (R) getArgument("rt", args);

      return new MOVZ_S(fd, fs, rt);
    }
  }
  public static final IInfo INFO = new Info();

  public final F fd;
  public final F fs;
  public final R rt;

  public MOVZ_S(final F fd, final F fs, final R rt) {
    assert F.INFO.isSupported(fd);
    assert F.INFO.isSupported(fs);
    assert R.INFO.isSupported(rt);
    this.fd = fd;
    this.fs = fs;
    this.rt = rt;
  }

  @Override
  public String syntax(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("MOVZ_S %s, %s, %s", fd.syntax(peState), fs.syntax(peState), rt.syntax(peState));
  }

  @Override
  public String image(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("01000110000%s%s%s010010", rt.image(peState), fs.image(peState), fd.image(peState));
  }

  @Override
  public void action(final PEState peState) {
    final PE pe__ = (PE) peState;
    if (rt.access(pe__).load().equals(Data.valueOf(WORD, 0x0))) {
      fd.access(pe__).store(fs.access(pe__).load());
    }
  }
}