/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vliw.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.PEState;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.vliw.PE;

import static ru.ispras.microtesk.model.vliw.TypeDefs.*;

public final class NOP extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         NOP.class,
         "NOP",
         new ArgumentDecls());
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      return new NOP();
    }
  }
  public static final IInfo INFO = new Info();

  public NOP() {
  }

  @Override
  public String syntax(final PEState peState) {
    final PE pe__ = (PE) peState;
    return "NOP";
  }

  @Override
  public String image(final PEState peState) {
    final PE pe__ = (PE) peState;
    return "00000000000000000000000000000000";
  }

  @Override
  public void action(final PEState peState) {
    final PE pe__ = (PE) peState;
  }
}