/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vliw.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.PEState;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.vliw.PE;
import ru.ispras.microtesk.model.vliw.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.vliw.TypeDefs.*;

public final class SLL extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         SLL.class,
         "SLL",
         new ArgumentDecls()
             .add("rd", R.INFO)
             .add("rt", R.INFO)
             .add("sa", INDEX));
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final R rd = (R) getArgument("rd", args);
      final R rt = (R) getArgument("rt", args);
      final Immediate sa = (Immediate) getArgument("sa", args);

      return new SLL(rd, rt, sa);
    }
  }
  public static final IInfo INFO = new Info();

  public final R rd;
  public final R rt;
  public final Immediate sa;

  public SLL(final R rd, final R rt, final Immediate sa) {
    assert R.INFO.isSupported(rd);
    assert R.INFO.isSupported(rt);
    assert INDEX.equals(sa.getType());
    this.rd = rd;
    this.rt = rt;
    this.sa = sa;
  }

  @Override
  public String syntax(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("SLL %s, %s, %d", rd.syntax(peState), rt.syntax(peState), sa.access(pe__).load().bigIntegerValue());
  }

  @Override
  public String image(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("00000000000%s%s%s000000", rt.image(peState), rd.image(peState), sa.access(pe__).load().toString());
  }

  @Override
  public void action(final PEState peState) {
    final PE pe__ = (PE) peState;
    rd.access(pe__).store(rt.access(pe__).load().shiftLeft(sa.access(pe__).load()));
  }
}