/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vliw.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.PEState;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.vliw.PE;
import ru.ispras.microtesk.model.vliw.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.vliw.TypeDefs.*;

public final class SW extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         SW.class,
         "SW",
         new ArgumentDecls()
             .add("base", R.INFO)
             .add("rt", R.INFO)
             .add("offset", SHORT));
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final R base = (R) getArgument("base", args);
      final R rt = (R) getArgument("rt", args);
      final Immediate offset = (Immediate) getArgument("offset", args);

      return new SW(base, rt, offset);
    }
  }
  public static final IInfo INFO = new Info();

  public final R base;
  public final R rt;
  public final Immediate offset;

  public SW(final R base, final R rt, final Immediate offset) {
    assert R.INFO.isSupported(base);
    assert R.INFO.isSupported(rt);
    assert SHORT.equals(offset.getType());
    this.base = base;
    this.rt = rt;
    this.offset = offset;
  }

  @Override
  public String syntax(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("SW %s, %d(%s)", rt.syntax(peState), offset.access(pe__).load().bigIntegerValue(), base.syntax(peState));
  }

  @Override
  public String image(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("101011%s%s%s", base.image(peState), rt.image(peState), offset.access(pe__).load().toString());
  }

  @Override
  public void action(final PEState peState) {
    final PE pe__ = (PE) peState;
    Location.concat(pe__.M.access(base.access(pe__).load().add(Data.signExtend(WORD, offset.access(pe__).load()))), pe__.M.access(base.access(pe__).load().add(Data.signExtend(WORD, offset.access(pe__).load())).add(Data.valueOf(WORD, 0x1))), pe__.M.access(base.access(pe__).load().add(Data.signExtend(WORD, offset.access(pe__).load())).add(Data.valueOf(WORD, 0x2))), pe__.M.access(base.access(pe__).load().add(Data.signExtend(WORD, offset.access(pe__).load())).add(Data.valueOf(WORD, 0x3)))).store(rt.access(pe__).load());
  }
}