/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vliw.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.PEState;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.vliw.PE;

import static ru.ispras.microtesk.model.vliw.TypeDefs.*;

public final class vliw extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         vliw.class,
         "vliw",
         new ArgumentDecls()
             .add("c1", channel1.INFO)
             .add("c2", channel2.INFO));
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final Operation c1 = (Operation) getArgument("c1", args);
      final Operation c2 = (Operation) getArgument("c2", args);

      return new vliw(c1, c2);
    }
  }
  public static final IInfo INFO = new Info();

  public final Operation c1;
  public final Operation c2;

  public vliw(final Operation c1, final Operation c2) {
    assert channel1.INFO.isSupported(c1);
    assert channel2.INFO.isSupported(c2);
    this.c1 = c1;
    this.c2 = c2;
  }

  @Override
  public String syntax(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("%s; %s;", c1.syntax(peState), c2.syntax(peState));
  }

  @Override
  public String image(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("%s%s", c1.image(peState), c2.image(peState));
  }

  @Override
  public void action(final PEState peState) {
    final PE pe__ = (PE) peState;
    pe__.NIA.access().store(pe__.CIA.access().load().add(Data.valueOf(WORD, 0x8)));
    pe__.GPR.access(0).store(Data.valueOf(WORD, 0x0));
    c1.execute(pe__);
    pe__.GPR.access(0).store(Data.valueOf(WORD, 0x0));
    c2.execute(pe__);
    if (pe__.BRANCH.access().load().equals(Data.valueOf(BIT, 0x0))) {
      pe__.CIA.access().store(pe__.CIA.access().load().add(Data.valueOf(WORD, 0x8)));
    } else {
      pe__.CIA.access().store(pe__.JMPADDR.access().load());
    }
  }
}