/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86.mode;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.PEState;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.api.memory.Location;
import ru.ispras.microtesk.model.x86.PE;

import static ru.ispras.microtesk.model.x86.TypeDefs.*;

public final class DOAM extends AddressingMode {
  public static final String NAME = "DOAM";

  private static final class Info extends InfoAndRule {
    Info() {
      super(
          DOAM.class,
          "DOAM",
          ADDR,
          new ArgumentDecls()
              .add("disp", WORD)
      );
    }

    @Override
    public AddressingMode create(final Map<String, Primitive> args) {
      final Immediate disp = (Immediate) getArgument("disp", args);
      return new DOAM(disp);
    }
  }

  public static final IInfo INFO = new Info();

  public final Immediate disp;

  public DOAM(final Immediate disp) {
    this.disp = disp;
  }

  @Override
  public String syntax(final PEState peState) {
    final PE pe__ = (PE) peState;
    init(pe__);
    return String.format("[%d]", disp.access(pe__).load().bigIntegerValue());
  }

  @Override
  public String image(final PEState peState) {
    final PE pe__ = (PE) peState;
    init(pe__);
    return String.format("%s", Location.concat(disp.access(pe__).bitField(8, 15), disp.access(pe__).bitField(0, 7)).load().toString());
  }

  public void init(final PEState peState) {
    final PE pe__ = (PE) peState;
    pe__.mod.access().store(Data.valueOf(Type.CARD(2), 0x0));
    pe__.rm.access().store(Data.valueOf(Type.CARD(3), 0x6));
  }

  @Override
  public void action(final PEState peState) {
    final PE pe__ = (PE) peState;
    init(pe__);
    pe__.instr_size.access().store(pe__.instr_size.access().load().add(Data.valueOf(SIZE, 0x2)));
  }

  @Override
  public Location access(final PEState peState) {
    final PE pe__ = (PE) peState;
    return new Location(Data.zeroExtend(ADDR, disp.access(pe__).load())).setName(syntax(pe__));
  }
}