/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86.mode;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.PEState;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.api.memory.Location;
import ru.ispras.microtesk.model.x86.PE;

import static ru.ispras.microtesk.model.x86.TypeDefs.*;

public final class RIAM_BX extends AddressingMode {
  public static final String NAME = "RIAM_BX";

  private static final class Info extends InfoAndRule {
    Info() {
      super(
          RIAM_BX.class,
          "RIAM_BX",
          ADDR,
          new ArgumentDecls()
      );
    }

    @Override
    public AddressingMode create(final Map<String, Primitive> args) {
      return new RIAM_BX();
    }
  }

  public static final IInfo INFO = new Info();

  public RIAM_BX() {
  }

  @Override
  public String syntax(final PEState peState) {
    final PE pe__ = (PE) peState;
    init(pe__);
    return "[BX]";
  }

  @Override
  public String image(final PEState peState) {
    final PE pe__ = (PE) peState;
    init(pe__);
    return "";
  }

  public void init(final PEState peState) {
    final PE pe__ = (PE) peState;
    pe__.mod.access().store(Data.valueOf(Type.CARD(2), 0x0));
    pe__.rm.access().store(Data.valueOf(Type.CARD(3), 0x7));
  }

  @Override
  public void action(final PEState peState) {
    final PE pe__ = (PE) peState;
    init(pe__);
  }

  @Override
  public Location access(final PEState peState) {
    final PE pe__ = (PE) peState;
    return new Location(Data.signExtend(ADDR, Data.cast(SWORD, pe__.BX.access().load()))).setName(syntax(pe__));
  }
}