/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.PEState;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.x86.PE;
import ru.ispras.microtesk.model.x86.mode.*;

import static ru.ispras.microtesk.model.x86.TypeDefs.*;

public final class ADC_R8IMM8 extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         ADC_R8IMM8.class,
         "ADC_R8IMM8",
         new ArgumentDecls()
             .add("op1", R8.INFO)
             .add("op2", IMM8.INFO),
         new Shortcuts()
             .addShortcut(new Info_x86(), "#root")
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final R8 op1 = (R8) getArgument("op1", args);
      final IMM8 op2 = (IMM8) getArgument("op2", args);

      return new ADC_R8IMM8(op1, op2);
    }
  }
  private static final class Info_x86 extends InfoAndRule {
    Info_x86() {
      super(
          x86.class,
          "ADC_R8IMM8",
          new ArgumentDecls()
              .add("op1", R8.INFO)
              .add("op2", IMM8.INFO)
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final R8 op1 = (R8) getArgument("op1", args);
      final IMM8 op2 = (IMM8) getArgument("op2", args);

      return new x86(
        new ADC_R8IMM8(
          op1,
          op2
        )
      );
    }
  }
  public static final IInfo INFO = new Info();

  public final R8 op1;
  public final IMM8 op2;

  public ADC_R8IMM8(final R8 op1, final IMM8 op2) {
    assert R8.INFO.isSupported(op1);
    assert IMM8.INFO.isSupported(op2);
    this.op1 = op1;
    this.op2 = op2;
  }

  @Override
  public String syntax(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("ADC %s, %s", op1.syntax(peState), op2.syntax(peState));
  }

  @Override
  public String image(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("1000000011000%s%s", op1.image(peState), op2.image(peState));
  }

  @Override
  public void action(final PEState peState) {
    final PE pe__ = (PE) peState;
    new add_proc_byte(new Immediate(op1.access(pe__).load().add(Data.valueOf(Type.CARD(8), 0x0))), new Immediate(op2.access(pe__).load().add(Data.zeroExtend(BYTE, pe__.CF.access().load())))).execute(pe__);
    op1.access(pe__).store(pe__.tmpb_res.access().bitField(0, 7).load());
    pe__.instr_size.access().store(pe__.instr_size.access().load().add(Data.valueOf(SIZE, 0x3)));
  }
}