/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.PEState;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.x86.PE;
import ru.ispras.microtesk.model.x86.mode.*;

import static ru.ispras.microtesk.model.x86.TypeDefs.*;

public final class IDIV_R16 extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         IDIV_R16.class,
         "IDIV_R16",
         new ArgumentDecls()
             .add("op1", GPR16.INFO),
         new Shortcuts()
             .addShortcut(new Info_x86(), "#root")
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final GPR16 op1 = (GPR16) getArgument("op1", args);

      return new IDIV_R16(op1);
    }
  }
  private static final class Info_x86 extends InfoAndRule {
    Info_x86() {
      super(
          x86.class,
          "IDIV_R16",
          new ArgumentDecls()
              .add("op1", GPR16.INFO)
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final GPR16 op1 = (GPR16) getArgument("op1", args);

      return new x86(
        new IDIV_R16(
          op1
        )
      );
    }
  }
  public static final IInfo INFO = new Info();

  public final GPR16 op1;

  public IDIV_R16(final GPR16 op1) {
    assert GPR16.INFO.isSupported(op1);
    this.op1 = op1;
  }

  @Override
  public String syntax(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("IDIV %s", op1.syntax(peState));
  }

  @Override
  public String image(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("1111011111000%s", op1.image(peState));
  }

  @Override
  public void action(final PEState peState) {
    final PE pe__ = (PE) peState;
    pe__.tmpdw_op1.access().bitField(0, 15).store(pe__.AX.access().load());
    pe__.tmpdw_op1.access().bitField(16, 31).store(pe__.DX.access().load());
    pe__.tmpdw_op2.access().store(pe__.tmpdw_op1.access().load().divide(Data.signExtend(DWORD, Data.cast(SWORD, op1.access(pe__).load()))));
    Execution.trace("delimoe %d delitel %d div %d", pe__.tmpdw_op1.access().load().bigIntegerValue(), Data.cast(SWORD, op1.access(pe__).load()).bigIntegerValue(), pe__.tmpdw_op2.access().load().bigIntegerValue());
    pe__.instr_size.access().store(pe__.instr_size.access().load().add(Data.valueOf(SIZE, 0x2)));
    if (!(((pe__.tmpdw_op2.access().load().compareTo(Data.valueOf(DWORD, 0x7fff)) > 0) || (pe__.tmpdw_op2.access().load().compareTo(Data.valueOf(DWORD, 0x8000)) < 0)))) {
      pe__.AX.access().store(Data.coerce(WORD, pe__.tmpdw_op2.access().load()));
      pe__.DX.access().store(Data.coerce(WORD, pe__.tmpdw_op1.access().load().mod(Data.signExtend(DWORD, Data.cast(SWORD, op1.access(pe__).load())))));
    }
  }
}