/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.PEState;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.x86.PE;
import ru.ispras.microtesk.model.x86.mode.*;

import static ru.ispras.microtesk.model.x86.TypeDefs.*;

public final class JMP_R16 extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         JMP_R16.class,
         "JMP_R16",
         new ArgumentDecls()
             .add("rel", GPR16.INFO),
         new Shortcuts()
             .addShortcut(new Info_x86(), "#root")
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final GPR16 rel = (GPR16) getArgument("rel", args);

      return new JMP_R16(rel);
    }
  }
  private static final class Info_x86 extends InfoAndRule {
    Info_x86() {
      super(
          x86.class,
          "JMP_R16",
          new ArgumentDecls()
              .add("rel", GPR16.INFO)
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final GPR16 rel = (GPR16) getArgument("rel", args);

      return new x86(
        new JMP_R16(
          rel
        )
      );
    }
  }
  public static final IInfo INFO = new Info();

  public final GPR16 rel;

  public JMP_R16(final GPR16 rel) {
    assert GPR16.INFO.isSupported(rel);
    this.rel = rel;
  }

  @Override
  public String syntax(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("JMP %s", rel.syntax(peState));
  }

  @Override
  public String image(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("1111111111000%s", rel.image(peState));
  }

  @Override
  public void action(final PEState peState) {
    final PE pe__ = (PE) peState;
    pe__.IP.access().store(pe__.IP.access().load().add(rel.access(pe__).load()));
    pe__.instr_size.access().store(pe__.instr_size.access().load().add(Data.valueOf(SIZE, 0x2)));
  }
}