/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.PEState;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.x86.PE;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.x86.TypeDefs.*;

public final class JO extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         JO.class,
         "JO",
         new ArgumentDecls()
             .add("rel", SBYTE),
         new Shortcuts()
             .addShortcut(new Info_x86(), "#root")
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final Immediate rel = (Immediate) getArgument("rel", args);

      return new JO(rel);
    }
  }
  private static final class Info_x86 extends InfoAndRule {
    Info_x86() {
      super(
          x86.class,
          "JO",
          new ArgumentDecls()
              .add("rel", SBYTE)
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final Immediate rel = (Immediate) getArgument("rel", args);

      return new x86(
        new JO(
          rel
        )
      );
    }
  }
  public static final IInfo INFO = new Info();

  public final Immediate rel;

  public JO(final Immediate rel) {
    assert SBYTE.equals(rel.getType());
    this.rel = rel;
  }

  @Override
  public String syntax(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("JO <label>%d", rel.access(pe__).load().bigIntegerValue());
  }

  @Override
  public String image(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("01110000%s", rel.access(pe__).load().toString());
  }

  @Override
  public void action(final PEState peState) {
    final PE pe__ = (PE) peState;
    if (pe__.OF.access().load().equals(Data.valueOf(BIT, 0x1))) {
      pe__.IP.access().store(pe__.IP.access().load().add(Data.signExtend(WORD, rel.access(pe__).load())));
    }
    pe__.instr_size.access().store(pe__.instr_size.access().load().add(Data.valueOf(SIZE, 0x2)));
  }
}