/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.PEState;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.x86.PE;
import ru.ispras.microtesk.model.x86.mode.*;

import static ru.ispras.microtesk.model.x86.TypeDefs.*;

public final class PUSH_M16 extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         PUSH_M16.class,
         "PUSH_M16",
         new ArgumentDecls()
             .add("seg_ovrd", RSEG16.INFO)
             .add("src", MOFFS.INFO),
         new Shortcuts()
             .addShortcut(new Info_x86(), "#root")
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final RSEG16 seg_ovrd = (RSEG16) getArgument("seg_ovrd", args);
      final AddressingMode src = (AddressingMode) getArgument("src", args);

      return new PUSH_M16(seg_ovrd, src);
    }
  }
  private static final class Info_x86 extends InfoAndRule {
    Info_x86() {
      super(
          x86.class,
          "PUSH_M16",
          new ArgumentDecls()
              .add("seg_ovrd", RSEG16.INFO)
              .add("src", MOFFS.INFO)
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final RSEG16 seg_ovrd = (RSEG16) getArgument("seg_ovrd", args);
      final AddressingMode src = (AddressingMode) getArgument("src", args);

      return new x86(
        new PUSH_M16(
          seg_ovrd,
          src
        )
      );
    }
  }
  public static final IInfo INFO = new Info();

  public final RSEG16 seg_ovrd;
  public final AddressingMode src;

  public PUSH_M16(final RSEG16 seg_ovrd, final AddressingMode src) {
    assert RSEG16.INFO.isSupported(seg_ovrd);
    assert MOFFS.INFO.isSupported(src);
    this.seg_ovrd = seg_ovrd;
    this.src = src;
  }

  @Override
  public String syntax(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("PUSH %s:%s", seg_ovrd.syntax(peState), src.syntax(peState));
  }

  @Override
  public String image(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("001%s11011111111%s000%s%s", seg_ovrd.image(peState), pe__.mod.access().load().toString(), pe__.rm.access().load().toString(), src.image(peState));
  }

  @Override
  public void action(final PEState peState) {
    final PE pe__ = (PE) peState;
    pe__.base.access().store(Data.zeroExtend(ADDR, seg_ovrd.access(pe__).load()).shiftLeft(Data.valueOf(ADDR, 0x4)));
    pe__.SP.access().store(pe__.SP.access().load().subtract(Data.valueOf(WORD, 0x2)));
    pe__.M.access(Data.zeroExtend(ADDR, pe__.SS.access().load()).shiftLeft(Data.valueOf(ADDR, 0x4)).add(Data.signExtend(ADDR, Data.cast(SWORD, pe__.SP.access().load())))).store(pe__.M.access(pe__.base.access().load().add(src.access(pe__).load())).load());
    pe__.M.access(Data.zeroExtend(ADDR, pe__.SS.access().load()).shiftLeft(Data.valueOf(ADDR, 0x4)).add(Data.signExtend(ADDR, Data.cast(SWORD, pe__.SP.access().load().add(Data.valueOf(WORD, 0x1)))))).store(pe__.M.access(pe__.base.access().load().add(src.access(pe__).load()).add(Data.valueOf(ADDR, 0x1))).load());
    src.execute(pe__);
    pe__.instr_size.access().store(pe__.instr_size.access().load().add(Data.valueOf(SIZE, 0x3)));
  }
}