/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.PEState;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.x86.PE;
import ru.ispras.microtesk.model.x86.mode.*;

import static ru.ispras.microtesk.model.x86.TypeDefs.*;

public final class PUSH_RSEG extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         PUSH_RSEG.class,
         "PUSH_RSEG",
         new ArgumentDecls()
             .add("src", RSEG16.INFO),
         new Shortcuts()
             .addShortcut(new Info_x86(), "#root")
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final RSEG16 src = (RSEG16) getArgument("src", args);

      return new PUSH_RSEG(src);
    }
  }
  private static final class Info_x86 extends InfoAndRule {
    Info_x86() {
      super(
          x86.class,
          "PUSH_RSEG",
          new ArgumentDecls()
              .add("src", RSEG16.INFO)
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final RSEG16 src = (RSEG16) getArgument("src", args);

      return new x86(
        new PUSH_RSEG(
          src
        )
      );
    }
  }
  public static final IInfo INFO = new Info();

  public final RSEG16 src;

  public PUSH_RSEG(final RSEG16 src) {
    assert RSEG16.INFO.isSupported(src);
    this.src = src;
  }

  @Override
  public String syntax(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("PUSH %s", src.syntax(peState));
  }

  @Override
  public String image(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("000%s110", src.image(peState));
  }

  @Override
  public void action(final PEState peState) {
    final PE pe__ = (PE) peState;
    pe__.base.access().store(Data.zeroExtend(ADDR, pe__.SS.access().load()).shiftLeft(Data.valueOf(ADDR, 0x4)));
    pe__.SP.access().store(pe__.SP.access().load().subtract(Data.valueOf(WORD, 0x2)));
    pe__.M.access(pe__.base.access().load().add(Data.signExtend(ADDR, Data.cast(SWORD, pe__.SP.access().load())))).store(src.access(pe__).bitField(0, 7).load());
    pe__.M.access(pe__.base.access().load().add(Data.signExtend(ADDR, Data.cast(SWORD, pe__.SP.access().load().add(Data.valueOf(WORD, 0x1)))))).store(src.access(pe__).bitField(8, 15).load());
    pe__.instr_size.access().store(pe__.instr_size.access().load().add(Data.valueOf(SIZE, 0x1)));
  }
}