/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.PEState;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.x86.PE;
import ru.ispras.microtesk.model.x86.mode.*;

import static ru.ispras.microtesk.model.x86.TypeDefs.*;

public final class XCHG_R16M16 extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         XCHG_R16M16.class,
         "XCHG_R16M16",
         new ArgumentDecls()
             .add("seg_ovrd", RSEG16.INFO)
             .add("dst", GPR16.INFO)
             .add("src", MOFFS.INFO),
         new Shortcuts()
             .addShortcut(new Info_x86(), "#root")
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final RSEG16 seg_ovrd = (RSEG16) getArgument("seg_ovrd", args);
      final GPR16 dst = (GPR16) getArgument("dst", args);
      final AddressingMode src = (AddressingMode) getArgument("src", args);

      return new XCHG_R16M16(seg_ovrd, dst, src);
    }
  }
  private static final class Info_x86 extends InfoAndRule {
    Info_x86() {
      super(
          x86.class,
          "XCHG_R16M16",
          new ArgumentDecls()
              .add("seg_ovrd", RSEG16.INFO)
              .add("dst", GPR16.INFO)
              .add("src", MOFFS.INFO)
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final RSEG16 seg_ovrd = (RSEG16) getArgument("seg_ovrd", args);
      final GPR16 dst = (GPR16) getArgument("dst", args);
      final AddressingMode src = (AddressingMode) getArgument("src", args);

      return new x86(
        new XCHG_R16M16(
          seg_ovrd,
          dst,
          src
        )
      );
    }
  }
  public static final IInfo INFO = new Info();

  public final RSEG16 seg_ovrd;
  public final GPR16 dst;
  public final AddressingMode src;

  public XCHG_R16M16(final RSEG16 seg_ovrd, final GPR16 dst, final AddressingMode src) {
    assert RSEG16.INFO.isSupported(seg_ovrd);
    assert GPR16.INFO.isSupported(dst);
    assert MOFFS.INFO.isSupported(src);
    this.seg_ovrd = seg_ovrd;
    this.dst = dst;
    this.src = src;
  }

  @Override
  public String syntax(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("XCHG %s, %s:%s", dst.syntax(peState), seg_ovrd.syntax(peState), src.syntax(peState));
  }

  @Override
  public String image(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("001%s11010000111%s%s%s%s", seg_ovrd.image(peState), pe__.mod.access().load().toString(), dst.image(peState), pe__.rm.access().load().toString(), src.image(peState));
  }

  @Override
  public void action(final PEState peState) {
    final PE pe__ = (PE) peState;
    pe__.base.access().store(Data.zeroExtend(ADDR, seg_ovrd.access(pe__).load()).shiftLeft(Data.valueOf(ADDR, 0x4)));
    Location.concat(dst.access(pe__).bitField(8, 15), dst.access(pe__).bitField(0, 7)).store(Location.concat(dst.access(pe__).bitField(8, 15), dst.access(pe__).bitField(0, 7)).load().xor(Location.concat(pe__.M.access(pe__.base.access().load().add(src.access(pe__).load()).add(Data.valueOf(ADDR, 0x1))), pe__.M.access(pe__.base.access().load().add(src.access(pe__).load()))).load()));
    Location.concat(pe__.M.access(pe__.base.access().load().add(src.access(pe__).load())), pe__.M.access(pe__.base.access().load().add(src.access(pe__).load()).add(Data.valueOf(ADDR, 0x1)))).store(Location.concat(pe__.M.access(pe__.base.access().load().add(src.access(pe__).load())), pe__.M.access(pe__.base.access().load().add(src.access(pe__).load()).add(Data.valueOf(ADDR, 0x1)))).load().xor(dst.access(pe__).load()));
    dst.access(pe__).store(dst.access(pe__).load().xor(Location.concat(pe__.M.access(pe__.base.access().load().add(src.access(pe__).load())), pe__.M.access(pe__.base.access().load().add(src.access(pe__).load()).add(Data.valueOf(ADDR, 0x1)))).load()));
    src.execute(pe__);
    pe__.instr_size.access().store(pe__.instr_size.access().load().add(Data.valueOf(SIZE, 0x3)));
  }
}