/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.PEState;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.x86.PE;
import ru.ispras.microtesk.model.x86.mode.*;

import static ru.ispras.microtesk.model.x86.TypeDefs.*;

public final class XCHG_R16R16 extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         XCHG_R16R16.class,
         "XCHG_R16R16",
         new ArgumentDecls()
             .add("dst", GPR16.INFO)
             .add("src", GPR16.INFO),
         new Shortcuts()
             .addShortcut(new Info_x86(), "#root")
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final GPR16 dst = (GPR16) getArgument("dst", args);
      final GPR16 src = (GPR16) getArgument("src", args);

      return new XCHG_R16R16(dst, src);
    }
  }
  private static final class Info_x86 extends InfoAndRule {
    Info_x86() {
      super(
          x86.class,
          "XCHG_R16R16",
          new ArgumentDecls()
              .add("dst", GPR16.INFO)
              .add("src", GPR16.INFO)
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final GPR16 dst = (GPR16) getArgument("dst", args);
      final GPR16 src = (GPR16) getArgument("src", args);

      return new x86(
        new XCHG_R16R16(
          dst,
          src
        )
      );
    }
  }
  public static final IInfo INFO = new Info();

  public final GPR16 dst;
  public final GPR16 src;

  public XCHG_R16R16(final GPR16 dst, final GPR16 src) {
    assert GPR16.INFO.isSupported(dst);
    assert GPR16.INFO.isSupported(src);
    this.dst = dst;
    this.src = src;
  }

  @Override
  public String syntax(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("XCHG %s, %s", dst.syntax(peState), src.syntax(peState));
  }

  @Override
  public String image(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("1000011111%s%s", dst.image(peState), src.image(peState));
  }

  @Override
  public void action(final PEState peState) {
    final PE pe__ = (PE) peState;
    dst.access(pe__).store(dst.access(pe__).load().xor(src.access(pe__).load()));
    src.access(pe__).store(src.access(pe__).load().xor(dst.access(pe__).load()));
    dst.access(pe__).store(dst.access(pe__).load().xor(src.access(pe__).load()));
    pe__.instr_size.access().store(pe__.instr_size.access().load().add(Data.valueOf(SIZE, 0x2)));
  }
}