/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.PEState;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.x86.PE;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.x86.TypeDefs.*;

public final class dec_proc_byte extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         dec_proc_byte.class,
         "dec_proc_byte",
         new ArgumentDecls()
             .add("op1", BYTE));
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final Immediate op1 = (Immediate) getArgument("op1", args);

      return new dec_proc_byte(op1);
    }
  }
  public static final IInfo INFO = new Info();

  public final Immediate op1;

  public dec_proc_byte(final Immediate op1) {
    assert BYTE.equals(op1.getType());
    this.op1 = op1;
  }

  @Override
  public void action(final PEState peState) {
    final PE pe__ = (PE) peState;
    pe__.tmpb_res.access().store(Data.zeroExtend(Type.CARD(9), op1.access(pe__).load().subtract(Data.valueOf(BYTE, 0x1))));
    pe__.OF.access().store(Data.valueOf(BIT, op1.access(pe__).bitField(7, 7).load().equals(Data.valueOf(Type.CARD(1), 0x0)) && pe__.tmpb_res.access().bitField(7, 7).load().equals(Data.valueOf(Type.CARD(1), 0x1))));
    pe__.ZF.access().store(Data.valueOf(BIT, pe__.tmpb_res.access().bitField(0, 7).load().equals(Data.valueOf(Type.CARD(8), 0x0))));
    pe__.SF.access().store(Data.valueOf(BIT, pe__.tmpb_res.access().bitField(7, 7).load().equals(Data.valueOf(Type.CARD(1), 0x1))));
  }
}