/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.PEState;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.x86.PE;

import static ru.ispras.microtesk.model.x86.TypeDefs.*;

public final class x86 extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         x86.class,
         "x86",
         new ArgumentDecls()
             .add("a", operations.INFO));
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final Operation a = (Operation) getArgument("a", args);

      return new x86(a);
    }
  }
  public static final IInfo INFO = new Info();

  public final Operation a;

  public x86(final Operation a) {
    assert operations.INFO.isSupported(a);
    this.a = a;
  }

  @Override
  public String syntax(final PEState peState) {
    final PE pe__ = (PE) peState;
    init(pe__);
    return a.syntax(pe__);
  }

  @Override
  public String image(final PEState peState) {
    final PE pe__ = (PE) peState;
    init(pe__);
    return a.image(pe__);
  }

  public void init(final PEState peState) {
    final PE pe__ = (PE) peState;
    pe__.instr_size.access().store(Data.valueOf(SIZE, 0x0));
  }

  @Override
  public void action(final PEState peState) {
    final PE pe__ = (PE) peState;
    init(pe__);
    a.execute(pe__);
    pe__.IP.access().store(pe__.IP.access().load().add(Data.zeroExtend(WORD, pe__.instr_size.access().load())));
    pe__.program_counter.access().store(Data.zeroExtend(ADDR, pe__.CS.access().load()).shiftLeft(Data.valueOf(ADDR, 0x4)).add(Data.zeroExtend(ADDR, pe__.IP.access().load())));
  }
}